<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - 7</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/hrsc.jpg">

<CENTER><H1>Cours/TD - (7)</H1>
</CENTER>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres6.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres8.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>23.11.99</FONT></H3>
<p>


<H2>Cours</H2>

<p>
Nous commençons la discussion de l'analyse syntaxique générale, mais en regardant toujours cette catégorie informatique comme un moyen de <EM>comprendre les programmes</EM>, car la forme syntaxique n'est qu'un moyen de structurer la sémantique d'un calcul. Nous allons donc commencer par un cadre conceptuel générique (universel), permettant une construction relativement facile des analyseurs pour une assez grande classe de langages, mais dont l'importance est <B>beaucoup</B> plus grande qu'un simple outil de construction des parseurs.
<p>

<H3>Introduction aux monades</H3>

Nous allons introduire un concept qui appartient à un domaine algébrique très abstrait, la théorie de catégories,  : les <EM>monades</EM>. Non, pas besoin de tomber dans les pommes <a href="javascript:alert('Attendez l\'examen, SVP...')">tout de suite</a>. Vous ignorez tout sur la théorie de catégories, vous ne conaissez pas les monades, mais vous les avez déjà pratiquées exactement comme monsieur Jourdain avait pratiqué la prose. Ce concept nous permet de définir le concept de "calcul" (angl.: <I>computation</I>) qui correspond à une "activité de l'ordinateur" : évaluation, transfert de contrôle, etc. Ceci facilite énormement l'application des techniques fonctionnelles à la construction des interprètes, parseurs, modules d'entrées/sorties, co-procédures, etc. L'importance des monades pour l'informatique a été reconnue relativement récemment par Eugenio Moggi, et son importance ne cesse pas de grandir. <SPAN class=ib>Lisez ce texte lentement.</SPAN>
<p>

Une monade est une abstraction, donc un concept général, qui peut avoir plusieurs "visages". Une monade est un type de données (abstrait) plus quelques opérations <I>génériques</I> (universelles) sur ce type de données. Prenons le modèle de programmation fonctionnelle le plus simple possible. L'ordinateur est une "calculatrice", qui effectue des opérations sur les données, en créant d'autres données. Le "calcul" (<I>computation</I>) se réduit à la gestion des données (constantes explicites) par l'application des fonctions. Nos <B>valeurs</B> appartiennent à un type de données : ceci peut être le type des nombres entiers ou flottants, ou un type avec des variantes comme le type <TT>Value</TT> <A HREF="comres5.html#defval">spécifié ailleurs</A>, etc. La seule opération <I>générique</I> sur ce type est l'application fonctionnelle (l'évaluation d'une expression). La seule chose qu'on peut faire avec le résultat est de lui appliquer une autre fonction. Nous avons défini ainsi la <EM>monade triviale</EM>. On l'appelera aussi : Monade 'Identité'. Nous savons très bien comment construire en quelques lignes un interprète récursif, descendant pour un tel "langage" (c'était notre premier modèle d'évaluateur).
<p>

Qu'est-ce qu'un "calcul", une activité, dans le cas plus général que notre calculatrice fonctionnelle? Nous devons y ajouter - par exemple :
<OL type="A">
<LI> Il faut savoir gérer les erreurs. Rappelons-nous, que nous définissons la sémantique de nos programmes de façon la plus complète possible. Rien ne doit rester caché sous la moquette, y compris les exceptions. Quelqu'un doit les gérér.
<LI> Il faut - éventuellement - gérer l'environnement, par exemple affecter les variables.
<LI> Il faut prévoir toute sorte de structures de contrôle, y compris le transfert de contrôle (branchement), permettant de coder les boucles, etc.
<LI> Il serait bien de pouvoir définir les opérations d'entrée/sortie de manière relativement transparente, sans trop de "<A HREF="javascript:alert('Au sens technique: quelque chose codé \npar une couche plus basse, irréductible')">magie</A>" totalement en dehors du contrôle utilisateur.

<li> On peut imaginer l'implantation du traçage d'exécution des programmes (pour le déboguage, analyse de la performance, etc.)
<li> On peut vouloir coder des protocoles sémantiques complexes comme le non-déterminisme, qui a déjà prové son utilité.
</OL>
Tout ceci peut être réalisé dans un <I>style monadique</I>. Son implantation en Haskell passe par un <SPAN class=ib>constructeur de types</SPAN> de données, paramétré par le type de nos valeurs de base. Supposons que les valeurs intéressantes pour nous appartiennent au type <TT>a</TT>. Ce sont des nombres, des objets de type Value, etc.
<p>

Alors  on notera par <TT><I>M</I> a</TT> le type "augmenté", "<I>lifté</I>" spécifié par la monade <TT><I>M</I></TT>, où <TT><I>M</I></TT> &nbsp; symbolise un constructeur de types concret, différent pour chaque monade. Exemples : les objets qui représentent les expressions de type <TT>a</TT>, mais dont l'évaluation peut échouer à cause des erreurs, peuvent appartenir à
<PRE>
data Maybe a = Nothing | Just a
</PRE>
un type déjà introduit, dont l'instance <TT>Nothing</TT> représente l'échec, et <TT>Just x</TT> est pour nous intuitivement équivalent à <TT>x</TT>. Ce type est prédéfini. 
<p>
Le nondéterminisme (des données) est introduit par le constructeur <TT>[]</TT>, c-à-d., les valeurs de type <TT>a</TT> seront remplacées par des collections de type <TT>[a]</TT>. On peut avoir plusieurs monades différentes dans le même programme, mais toutes doivent permettre la surcharge de quelques opérations universelles.
<p>

La première opération monadique est le "lifting" qui transforme une valeur "ordinaire" en calcul, l'"injection" d'une donnée dans le monde monadique. On l'appelle <TT>return</TT>. Pour la monade triviale le lifting est trivial aussi : <TT>return x = x</TT>, ou <TT>return=id</TT>. (En tout cas : le nom <TT><I>return</I></TT> est historique, et n'a absolument rien à voir avec le retour d'une fonction ! Autres noms comme <TT>result</TT> ou <TT>unit</TT> n'ont pas été acceptés, dommage...)
<p>

Pour la monade <TT>Maybe</TT> :  <TT>return x = Just x</TT>, quoi d'autre?... Également, pour la monade <TT>[]</TT> : <TT>return x = [x]</TT> (une réponse non-déterministe qui contient une seule variante).  Nous pouvons élargir notre monade <TT>Maybe</TT> : si les opérations (arithmétiques ou autres) risquent de générer plusieurs exceptions, comme la division par zéro, racine d'un nombre négatif, séparation de la tête d'une chaîne vide, etc., nous pouvons définir un type spécial <TT>Exception</TT> avec les variantes qui correspondent aux circonstances, et définir la monade
<PRE>
data Calc a = Er Exception | CJust a
</PRE>
avec <TT>return x = CJust x</TT>
<p>

Un autre exemple,<SPAN class=ib>relativement difficile !</SPAN>. Supposons que notre machine "fait" quelque chose, exerce une activité procédurale liée au changement d'état. (Disons <I>cum grano salis</I> :  elle produit les effets de bord, comme la modification d'une variable.) Alors, les entités intéressantes dans notre programme ne sont plus seulement les "valeurs" de type <TT>a</TT>, mais les paires de type <TT>(a,s)</TT>, où <TT>s</TT> définit le type "état". 
<p>

L'état peut être assez compliqué, par exemple l'environnement associatif, mais il peut être un simple compteur qui permet d'analyser le fonctionnement de la machine, et qui est incrémenté à chaque exécution d'une opération tracée. Il y a un petit problème : si nous voulons garder une vision abstraite de notre "calcul" qui transforme l'état du système, nous aurons besoin de <SPAN class=ib>deux types de base</SPAN>. Il est possible en principe de définir le type 
<PRE class="rp">
type ST a s = (a,s)
</PRE>
("<TT>ST</TT>" comme <I>State Transformer</I>), mais en fait, l'état doit obligatoirement être "caché" de notre vue. Ce qui nous intéresse <I>vraiment</I> ce sont des <I>données</I>, le résultat du calcul, et non pas ses "détails internes". L'enchaînement des fonctions doit, certes, pouvoir changer l'état, c'est-à-dire <EM>génerer un état nouveau à partir de l'anceien</EM>, mais si on laisse l'état "visible" dans le programme, il perd immédiatemment sa propriété fondamentale : <EM>d'être unique</EM>. On pourra faire n'importe quoi avec, et opérer simultanément sur un nombre quelconque d'états ; bref, il devient une donnée comme les autres, et on revient à la monade triviale, avec un autre type de données, plus complexe. Ce n'est pas ce que nous voulons !
<p>

Par contre, si l'état est caché, une implantation sophistiquée peut assurer que toutes les modifications qui génèrent le nouvel état, en fait modifient physiquement l'original, ce qui est équivalent au protocole de programmation impérative.
<p>


Sachant que chaque manipulation des valeurs peut "changer" l'état, nous pouvons définir cette monade différemment :
<PRE>
type ST a s = s -&gt; (a,s)
</PRE>

Ceci n'est pas très simple à comprendre, allons doucement. Au lieu d'avoir une valeur comme une chaîne, un entier, etc., la "valeur" de base est une fonction, un objet "opaque" qui ne permet à l'utilisateur aucun "bricolage". La <SPAN class=ib>seule</SPAN> chose que nous pouvons faire avec, c'est de l'appliquer, appliquer à une donnée de type "état", ce qui permet de récupérer la valeur et aussi l'état après.
<p>

Le "lifting" monadique ici aura la forme
<PRE>
return x = \s -&gt; (x,s)
</PRE>
c'est-à-dire : une valeur <TT>x</TT> se transforme en une fonction qui agissant sur l'état <TT>s</TT> le récupere <I>sans modifications</I>, et construit la paire : (valeur, s). La conversion des simples données en quelque chose si abstraite n'est pas facile à maîtriser, mais après quelques exemples on commencera à apprécier l'énorme puissance de la technique.
<p>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3>Composition des fonctions monadiques</H3>

Si la monade n'est pas triviale, ce qui était l'application fonctionnelle devient plus sophistiqué. Par exemple, un échec dans la monade <TT>Maybe</TT>, ou non-déterministe doit se propager, on ne peut normalement faire rien avec, jusqu'au moment de quitter le protocole monadique. Pour l'instant nous avons l'opérateur <TT>return</TT> permettant d'y entrer. Maintenant il faut savoir propager les objets monadiques, construire les uns à partir des autres, étendre la notion d'application fonctionnelle, faire des expressions monadiques. Dans le Prélude Standard il existe l'opérateur <TT>(&gt;&gt;=)</TT> (ne me demandez pas pourquoi cette forme bizarre...), qui agit dans le contexte <TT>m &gt;&gt;= f</TT>, où <TT>m</TT> est un objet monadique, une valeur déjà "liftée", et <TT>f</TT> - une fonction. Notre opérateur <TT>&gt;&gt;=</TT>
<UL type="disc">
<LI> prend un objet monadique, de type <TT>(M a)</TT> pour un certain constructeur monadique <TT>M</TT> et un certain (compatible) type <TT>a</TT>,
<LI> prend une fonction, qui à partir d'une "valeur normale" construit un objet monadique, (donc, <TT>f :: a -&gt; M b</TT>, où <TT>b</TT> peut être un autre type "monadisable", mais souvent c'est le même type <TT>a</TT>),
<LI> récupère - de manière spécifique, différente pour chaque monade <TT>M</TT> - "la valeur y cachée" (si elle existe),
<LI> applique (ou non) ladite fonction, aussi de manière qui dépend de la monade en question, et
<LI> retourne le résultat de cette application généralisée. Le résultat appartient au type <TT>M b</TT>.
</UL>
Évidemment, on a besoin de <I>plusieurs</I> exemples, pour comprendre cette stratégie (je vous ai dit qu'il faut passer quelques nuits avec les monades, et ceci n'est pas seulement une plaisanterie). Pour la monade triviale, l'opérateur <TT>(&gt;&gt;=)</TT> se réduit à l'application à l'envers : <TT>m &gt;&gt= f = f m</TT>. Le nom anglais de cet opérateur est "<i>bind</i>".
<p>

Pour la monade <TT>Maybe</TT> la définition est suivante :
<PRE>
Just x  &gt;&gt;= k = k x
Nothing &gt;&gt;= k = Nothing
</PRE>
nous pouvons, d'ailleurs, définir encore une fonction générique <TT>fail</TT>, qui symbolise l'échec :
<PRE>
fail x = Nothing
</PRE>
Pour la monade non-déterministe réalisée avec des simples listes, sans introduire le type des "collection de réponses" spécial :
<PRE>
return x     = [x]      -- nous le savons déjà.
fail s       = []

(x:xs) &gt;&gt;= f = f x ++ (xs &gt;&gt;= f)
[]     &gt;&gt;= f = []
</PRE>
(Notez que <i>bind</i> dans notre cas est la <A HREF="comres3.html#mapcon">fonctionnelle <TT>mapcon</TT></A> ! ou <TT>concat . map f</TT>.)
<p> 


Et pour les transformateurs d'états? Dans l'expression <TT>(m &gt;&gt; f)</TT>, l'objet <TT>m</TT> est une fonction, il faut donc l'appliquer à quelque chose, concrètement à l'état original du système <TT>t</TT> au moment de l'exécution du <i>bind</i>. Supposons que le résultat obtenu est la paire <TT>(x, t1)</TT>. Ensuite la fonction <TT>f</TT> agit sur <TT>x</TT>, et génère un objet monadique - la fonction qui doit agir sur l'état <TT>t1</TT> pour continuer le calcul. Voici la définition complète :
<PRE>
m &gt;&gt;= f =
  \t -&gt; let (x,t1) = m t   -- m s'applique à l'état orig.
        in let (y,t2) = f x t1 -- f : au résultat de m
           in (y,t2) 
</PRE>
(En fait, la destructuration <TT>(y,t2)</TT> de l'appel de <TT>f</TT> est uniquement pour vos beaux yeux, le programme n'en a pas besoin (ici), nous la pouvons remplacer par une simple variable.
<p>

<EM>Les fonctions de combinaison monadique <TT>return</TT> et <TT>(&gt;&gt;=)</TT> ne font rien de particulier, elles permettent d'organiser votre programme</EM>. Si vous devez coder des opérations concrètes sur des données concrètes, les monades établissent un style de codage, mais le "vrai" travail est à faire. Dans des programmes impératifs la notion d'état est globale, implicite. L'objet - état subit des modifications par des effets de bord, "sous la moquette". Dans la programmation fonctionnelle l'état est explicit, et il n'y a pas d'effets de bord. On "change" l'état en construisant un nouveau.


Pour éviter sa "modification" inopinée, les monades aident à le "cacher sous la moquette", ce qui simplifie le programme, et établit la possibilité de son optimisation, par exemple l'implantation de la monade <TT>ST</TT> par des opérations primitives, irréductibles, comme nous avons déjà suggéré. Normalement les listes, nombres, etc. sont aussi implantés par des primitives "magiques", même si nous pouvons les simuler par les constructions fonctionnelles (voir notre digression sur les <A HREF="comint6.html#arpeano">numéraux de Church</A>, et <A HREF="comint6.html#fundata">tuples fonctionnelles</A>).
<p>


Voici donc un exemple concret : la modification d'un programme "classique" qui ajoute 1 à un compteur chaque fois quand une opération (d'une classe précisée par l'utilisateur) est exécutée. Définissons un type qui représente l'état-compteur, et la monade (<TT>Calcul</TT>) correspondante :
<PRE>
type State = Integer
type Calcul a = State -&gt; (a,State)
</PRE>
Construisons une fonction auxiliaire qui agit seulement sur l'état, et qui incrémente le compteur. C'est un transformateur d'états qui renvoie une valeur "bidon", sans propriétés, identifiée en Haskell par le symbole <TT>()</TT>, et prononcée "<I>unit</I>".
<PRE>
tick = \t -&gt; ((),t+1)        -- "Tick !"
</PRE>
Si un ensemble de fonctions "normales" : <TT>f, g, h</TT> qui agissent sur les valeurs <TT>x, y, z</TT> doit être "tracé", c'est-à-dire si chaque appel d'une de ces fonctions doit incrémenter le compteur, on définit d'abort les fonctions "liftées" p. ex. <TT>f' = lift f</TT> :
<PRE>
(lift f) x s = tick &gt;&gt; (\_ -&gt return (f x)
</PRE>
et dans le programme on monadise d'abord les données d'entrée, toutes les valeurs numériques standard <TT>x</TT> passent à <TT>return x</TT>, etc., et ensuite toutes les applications des fonctions <TT>f</TT> et autres, sont converties en <i>bind</i> avec <TT>f'</TT>, etc. Le "résultat du programme monadique" est une fonction qui doit être appliqué à l'état initial, par exemple à la valeur 0 : l'état initial du compteur. Après la terminaison du programme monadique on récupère la valeur finale "principale", et la valeur du compteur. Notez que le compteur reste totalement invisible et inaccessible pendant l'exécution du programme, on ne peut pas le détruir par mégarde.
<p>

Pour la monade <TT>Maybe</TT> censée de représenter les erreurs/échecs, les opérateurs <TT>return</TT> et <TT>(&gt;&gt;)</TT> permettent à peine d'injecter une valeur normale dans le domaine monadique, et de propager l'erreur (<TT>Nothing</TT>) à travers les fonctions. Mais c'est à nous de définir les fonctions spécifiques qui génèrent les erreurs (ou qui permettent de récupérer le contrôle après la neutralisation de l'erreur). Par exemple, si les opérations arithmétiques standard agissent sur les nombres flottants, et si nous voulons contrôler l'action de division par zéro, nous povons définir
<PRE>
dvd x y | y==0.0 = Nothing
        | otherwise = return (x/y)   -- (ici: Just (x/y) )
</PRE>
Si le calcul précédent a construit deux objets : <TT>a</TT> et <TT>b</TT>, qui peuvent être égaux à <TT>Just x</TT> ou <TT>Nothing</TT>, et : <TT>Just y</TT> ou <TT>Nothing</TT>, la division demande l'exécution de l'enchaînement suivant :
<PRE>
a &gt;&gt;= \x -&gt; (b &gt;&gt;= \y -&gt  x `dvd` y) 
</PRE>
Le premier opérateur <TT>(&gt;&gt;=)</TT> vérifie <TT>a</TT>, et si son évaluation précédente s'est soldée par un échec, on ne regarde même pas le reste - la fonction <TT>\x ...</TT> ne sera jamais appliquée. Sinon, cette fonction commence par appliquer <B>bind</B> à <TT>b</TT>, et la situation se répète : si <TT>y</TT> ne peut pas être extrait, le résultat du second <B>bind</B> passé au premier est <TT>Nothing</TT>. Si les deux arguments sont correctes, la division augmentée peut bomber aussi.
<p>

Il est évident, que la syntaxe de cet enchaînement n'est pas très bien adaptée aux yeux humains. Mais ceci peut être généré par un compilateur à partir de <B>"a/b"</B>. 
<p>


Nous allons suspendre cette présentation générale des monades, et élaborer grâce à ces concepts quelques techniques d'analyse descendante, et plus tard - de la génération du code. Mais, pour la dernière fois : les monades ne font aucun travail à notre place, et toutes les fonctions spécifiques doivent être définies. Par exemple, dans le cas de la monade non-déterministe l'opérateur <SPAN class=ib>essentiel</SPAN> est l'alternative inclusive, implantée par la concaténation, et celle là n'est pas automatiquement générée par un magicien monadique. Plus tard nous connaîtrons encore au moins deux monades :
<UL type="disc">
<LI> Continuations, et
<LI> Entrées/Sorties.
</UL>
Il nous faudra aussi faire une digression, et apprendre comment on surcharge les fonctions plymorphes en Haskell, grâce au système de <SPAN class=ib>classes de types</SPAN>.


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>


<H3>Les parseurs</H3>

Après cette excursion un peu formaliste, mais pratique, directement implémentable et utile, nous revenons à la construction des parseurs. Nous avons besoin de deux concepts monadiques différents. 
<p>

<IMG SRC="../icons/strobe.gif" WIDTH="16" HEIGHT="16" ALT=""> &nbsp; Le premier est le non-déterminisme lié à l'ambiguïté du parsing, la possibilité d'avoir plusieurs réponses. Même si à la fin on élimine toutes les réponses redondantes, durant les étapes partielles l'analyse peut être ambiguë. <SPAN class=ib>(Ceci souvent peut être entièrement évité, mais le parseur devient compliqué, et notre but est de montrer comment faire des parseurs simples. Ceci dit, nous n'envisageons nullement pas faire des jouets théoriques. L'efficacité reste pour nous un attribut important de toute la programmation, nous ne voulons seulement pas gaspiller deux mois du temps humain pour gagner deux secondes de travail d'une bestiole électronique)</SPAN>
<p>

<IMG SRC="../icons/strobe.gif" WIDTH="16" HEIGHT="16" ALT=""> &nbsp; L'autre concept monadique est <I>l'état</I> : le flot d'entrée qui est séquentiellement consommé. Dans un langage impératif on effectue la "lecture", on lance une fonction comme <TT>scanf, get, read, input</TT>, etc. selon le langage, et cette fonction retourne la valeur récupérée du tampon d'entrée. La lecture suivante accède à, et retourne l'item suivant. Cette invisibilité du tampon d'entrée peut être une bonne chose : le programme est plus simple, on voit moins de détails. Mais d'autre part, il est <EM>beaucoup</EM> plus difficile de construire un parseur non-déterministe - chaque réponse alternative doit retourner également l'état du sous-système d'entrée différent, et ceci n'est pas possible, si l'accès au tampon se fait à travers des procédures déterministes et destructives type "<TT>read</TT>". Voici à présent notre stratégie monadique.
<p>


Un <I>parseur universel</I> est une entité qui appartient au type suivant :
<PRE>
type UParser c a = [c] -&gt; [(a,[c])]
</PRE>
Un objet de ce type est une fonction qui agit sur un flot (liste) de données, par exemple la liste de caractères pour l'analyse lexicale, ou une liste de mots pour le parseur syntaxique. Le résultat est non-déterministe : une collection de réponses du type <TT>a</TT> (p. ex. les arbres syntaxiques ; pour un analyseur lexical <TT>a</TT> sera le type "Symbole" : les identificateurs, nombres, opérateurs faits de caractères spéciaux, séparateurs, etc.), appariées avec le flot restant, qui peut être différent pour chaque variante de réponses. Un parseur universel peut aussi être un générateur de code, consommer un flot d'arbres syntaxiques, et générer le code postfixe. Le parseur universel constitue une monade, avec les primitives assez triviales à comprendre :
<PRE>
return x = \inp -&gt [(x,inp)]
fail = \inp -&gt; []
</PRE>
Aucune de deux ne consomme rien ; le parseur <TT>return</TT> sera appliqué dans le contexte où ses prédecesseurs ont déjà récupéré quelque chose d'intéressant, tout a été placé dans <TT>x</TT>, et <TT>return x</TT> effectue le "montage final" d'un résultat, sans toucher plus le flot d'entrée (jusqu'à nouvel ordre). La sémantique de l'échec est évidente. Après l'échec on ne peut plus continuer le parsing.
<p>

<SPAN class=ib>Suggestion.</SPAN> regardez la construction des parseurs des expressions algébriques, et essayez d'en déduire la forme de l'opérateur <TT>(&gt;&gt;=)</TT>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>TD</H2>
<p>
<H3>Retour aux algorithmes non-déterministes. Style monadique</H3>
<p>

Comment coder le générateur de permutations avec les combinateurs monadiques? Rappelons la solution en Prolog, traduite mécaniquement, sans aucune intelligence, en pseudo-Haskell (erroné !) :
<PRE class="rp">
perm [] = []
perm (x:q) = let r = perm q in nd_insert x r

nd_insert x [] = [x]     -- -- sinon ...
nd_insert x l = x:l
nd_insert x (y:q) = y : nd_insert x q
</PRE>
La solution monadique proposée ci-dessous est légèrement moins efficace que <A HREF="comres3.html#insnd">celle trouvée précédemment</A> : <TT>[a] ++ l</TT> doit être réduit à <TT>a : l</TT>, mais l'optimisation peut suivre la création d'une maquette monadique, facile à écrire mécaniquement. Commençons par l'insertion :
<PRE>
nd_insert x [] = return [x]
nd_insert x l@(y:q) = return (x:l) ++
    (nd_insert x q &gt;&gt;= \h -&gt; return (y:h) )
</PRE>
où la dernière ligne peut être simplifiée à
<PRE>
    (nd_insert x q &gt;&gt;= return . (y:) )
</PRE>
<SPAN class=ib>Attention !</SPAN> En Prolog la première clause (insertion dans la liste vide) est redondante, la solution est incluse dans la réponse donnée par la deuxième clause. En Haskell la première devient irréductible ; dans ce cas la solution est déterministe : <TT>[x]</TT>. Par contre, les deux restantes filtrent le même jeu d'arguments d'entrée - une liste non vide. L'alternative est implémentée par <TT>(++)</TT>, et le reste est mécanique. Les permutations se traduisent aussi mécaniquement :
<PRE>
perm [] = return []
perm (x:q) = perm q &gt;&gt;= nd_insert x
</PRE>
(où nous avons simplifié la dernière ligne, dont la version d'origine est
<PRE>
   perm (x:q) = perm q &gt;&gt;= \r -&gt; nd_insert x r
</PRE>
<p>

Faites SVP vous mêmes la traduction monadique du <I>powerset</I> et les combinaisons. 



<!-- ********************************************************* -->
<p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3>Déclaration des listes Prolog</H3>
<P>

Même si on n'a aucune volonté d'apprendre les algorithmes du parsing, et seulement exploiter les outils existants, comme Yacc, une certaine connaissance du processus s'avère utile. En effet, Yacc, ou Gentle, ou ANTLR, etc. peuvent générer pour nous un parseur à partir d'une grammaire, mais si nous construisons cette grammaire de manière négligeante, le parseur résultant sera horrible ! (Franchement, la plupart des parseurs construits automatiquement est horrible, lourde et lente...) Quelques techniques comme la factorisation ou élimination des clauses récursives à gauche doivent être maitrisées. Nous avons déjà travaillé sur les expressions algébriques. Construisons à présent une <SPAN class=ib>liste</SPAN>, pour figer la syntaxe ce sera une liste en Prolog : <TT>[a,b, ...]</TT>, éventuellement <TT>[a,b, ...,x|z]</TT>. Elle peut être vide, mais on ne peut pas avoir la virgule ou la barre verticale au début, ni à la fin, ni deux virgules consécutives. Les objets stockés dans une liste ce sont des termes Prolog quelconques, y compris les listes. (Donc, les listes sont hétèrogènes, comme en Lisp. Les listes en Haskell ajoutent quelques contraintes, l'équivalent de la barre n'existe pas, même si nous avons l'opérateur <TT>(:)</TT>.
<p>

Nous avons vu plusieurs solutions alternatives. Ce qui serait judicieux est l'élimination du non-déterminisme inutile, par exemple l'existence d'une production qui filtre une liste vide <TT>[]</TT> ou une liste non-vide, qui commence également par le crochet. Si la "mauvaise" variante est appliquée en premier, le parseur recule, et <SPAN class=ib>consomme le crochet ouvrant pour la deuxième fois.</SPAN> La solution qui factorise les éléments "obligatoires", p. ex. le crochet ouvrant, sera sans doute meilleure. Voici le symbole de départ, ainsi que la définition d'un élément de liste (un terme Prolog) :
<PRE class="he">
terme ::= atome | terme_func | liste

liste ::= [liste']
</PRE>
le non-terminal <TT>liste'</TT> peut être vide, sinon, c'est une séquence de termes, au moins un, mais la virgule y est présente s'il y a au moins deux.
<PRE>
liste' ::= EPS | terme seqt
seqt ::= EPS | , terme seqt | "|" terme
</PRE>
(Quelques dialectes de Prolog permettaient la notation <TT>[|A]</TT>, ce qui était équivalent à <TT>A</TT>, mais oublions cet exotisme.)
<p>

Voici le parseur, écrit en Prolog, testez-le !. Mais la traduction en Haskell sera présentée plus tard (style monadique ; essayez de le faire vous même, c'est un bon sujet d'examen). Le parsing de <TT>[a|b]</TT> doit générer le terme <B>cons(a,b)</B>, et la liste vide est représentée par <B>nil</B>. Le prédicat <B>terme</B> vérifie la validité de l'objet, et ne joue aucun autre rôle particulier ici.
<PRE class="he">
liste(['['|LT],LQ,Res) :- listep(LT,[']'|LQ],Res).
listep([X|Q],Lr,cons(X,P)) :- terme(X), seqt(Q,Lr,P).
listep(L,L,nil).

seqt(['|',Last|Q],Q,Last).
seqt([',',Next|Lp],Lq,cons(Next,S)) :- terme(Next), seqt(Lp,Lq,S).

seqt(L,L,nil).
</PRE>

La liste <B>[alpha,b,c,|34]</B> sera parsée comme <TT>cons(alpha,(cons(b,cons(c,34))))</TT>, et <B>[a,b]</B> comme <TT>cons(a,cons(b,nil))</TT>.



<H3>Déclarations en "C"</H3>

Ceci est un exercice en révision de vos connaissances de ce langage, et nous n'allons pas consacrer trop de place à la discussion qui a eu lieu. L'exercice avait pour but spécifier de façon formelle les déclarations en C/C++, et il faut avouer que c'est raté... 
<p>

Nous avons toutefois précisé qu'une telle déclaration
<UL type="disc">
<LI> commence par un mot-modificateur optionnel : <TT>static</TT>, <TT>register</TT>, <TT>const</TT> etc. Quelques modificateurs sont compatibles, autres non. Il n'est pas facile de préciser un simple règle syntaxique pour cela.
<LI> Ensuite vient le <SPAN class=ib>type</SPAN> : <TT>int, double</TT>, etc., éventuellement les structures ou variantes : <TT>struct <I>nom</I> {}</TT>, ou <TT>union</TT> ...
<LI> Aussi, un type synonymique quelconque, introduit par  <TT>typedef</TT>. Donc, en fait, le type peut être un identificateur quelconque, et la validité est reconnue sémantiquement.
<LI> Ensuite vient la liste des <I>variables</I> séparée par les virgules. Au moins cela possède une syntaxe disciplinée, voir notre exercice précédent...
<LI> Une variable peut être
<UL type="square">
	<LI> un nom,
	<LI> un decripteur de tableau : <TT>v[<I>Dim</I>]</TT>, où <TT>v</TT> peut être une variable (la spécification des tableaux est récursive), et la dimension est optionnelle, à condition d'avoir initialisé explicitement le tableau ;
	<LI> un pointeur <TT>*v</TT>, où <TT>v</TT> peut aussi être une variable quelconque
	<LI> un pointeur sur une fonction <TT>(*v)()</TT>.
</UL>
<LI> Une variable peut être suivie par une initialisation : une constante simple, un tableau <TT>{ ...}</TT>, une chaîne <TT>" ... "</TT>, etc. Les règles définissant les initialisations valises ont leur propre complexité.
</UL>

Je vous suggère de regarder un livre ou les tutoriaux sur le Web consacrés au langage C, et une fois focaliser votre attention sur la définition formelle du langage, sur le plan strictement syntaxique. Ceci vous fera du bien. Vous vous rendez compte que si un langage est si mal décrit formellement, son compilateur obligatoirement sera très grand.
<p>

Les déclarations sont des entités statiques dans le programme, elles ne correspondent à aucun code exécutable (sauf, éventuellement le code d'initialisation d'une variable non-statique dans un bloc). Le parseur correspondant n'est pas lié à un générateur de code, mais à quelques procédures sémantiques importantes, qui assemblent la table des symboles, et construisent la <EM>liste des attributs</EM> pour ces symboles. On en parlera plus tard, et on précisera quelle est la relation entre une production syntaxique et sa "décoration" par des procédures sémantiques qui gèrent les attributs. Si vous avez déjà entendu parler des grammaires attribuées, revisez vos notes.


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres6.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres8.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
